// Battery SSDT for FX503.
// by cowcowpod/cowpod
// requires acpi patches _Q20->XQ20, SELE->XELE, _BST->XBST, UPBI->XPBI, UPBS->XPBS 
DefinitionBlock ("", "SSDT", 2, "hack", "BATT", 0x00000000)
{
    External (_SB.PCI0.LPCB, DeviceObj)
    External (_SB.PCI0.LPCB.EC0, DeviceObj)
    External (_SB.BAT1, DeviceObj)
    External (_SB.ATKP, IntObj)
    External (_SB.BAT1.CHBP, MethodObj)
    External (_SB.PCI0.LPCB.EC0.MUT0 , MutexObj)
    External (_SB.PCI0.LPCB.EC0.TBAT, IntObj)
    External (_SB.PCI0.LPCB.EC0.BATF, IntObj)
    External (_SB.PCI0.LPCB.EC0.BATN, IntObj)
    External (_SB.PCI0.LPCB.EC0.BATO, IntObj)
    External (_SB.PCI0.LPCB.EC0.ACEV, IntObj)
    External (_SB.PCI0.LPCB.EC0.ACIN, FieldUnitObj)
    External (_SB.ATKD.IANE, MethodObj)
    External (_SB.ACAD, DeviceObj)
    External (\PWRS, FieldUnitObj)
    External (\PNOT, MethodObj)
    External (_SB.PCI0.LPCB.EC0.ECOK, IntObj)
    External (_SB.BAT1.TBAT, IntObj)
    External (_SB.BAT1.IVBS, MethodObj)
    External (_SB.BAT1.PBST, PkgObj)
    External (_SB.BAT1.PBIF, PkgObj)
    Scope (\)
    {
        Method (B1B2, 2, NotSerialized)
        {
            Return (Or (Arg0, ShiftLeft (Arg1, 0x08)))
        }
    }

    Scope (_SB.PCI0.LPCB)
    {
        Scope (EC0)
        {
            OperationRegion (ERM2, EmbeddedControl, Zero, 0xFF)
            Field (ERM2, ByteAcc, NoLock, Preserve)
            {
                Offset (0x15), 
//                FLHB,   8, 
//                FLHE,   8, 
//                FLHH,   8, 
//                SMPR,   8, 
//                SMST,   8, 
//                SMAD,   8, 
                Offset (0x1C), 
//                SMD0,   32,
                Offset (0x3C), 
//                SMAA,   8, 
//                SMAR,   8, 
//                SAD0,   8, 
//                SAD1,   8, 
                Offset (0x42), 
//                KBID,   3, 
//                MID1,   1, 
//                MID2,   1, 
//                OSFF,   1, 
//                    ,   1, 
//                MEFW,   1, 
                Offset (0x44), 
//                ACIN,   1, 
//                RTCF,   1, 
//                RVCC,   1, 
//                SWIS,   1, 
//                    ,   1, 
//                RVS3,   1, 
//                PSAD,   1, 
                Offset (0x46), 
                BCT0,8,BCT1,8, 
                CRP0,8,CRP1,8, 
                BVT0,8,BVT1,8, 
//                MBC2,   16,
//                RCA2,   16,
//                MBV2,   16,
//                    ,   3, 
//                WLRF,   1, 
//                BLPW,   1, 
//                LIDS,   1, 
//                PWBN,   1, 
                Offset (0x58), 
//                CTMP,   8, 
//                FAND,   1, 
//                    ,   1, 
//                VGAT,   1, 
//                    ,   2, 
//                S3LW,   1, 
//                APSD,   1, 
                Offset (0x5B), 
//                CCDS,   1, 
                Offset (0x5D), 
//                LIDE,   1, 
                Offset (0x5E), 
//                NOAC,   1, 
//                    ,   5, 
//                TUFA,   1, 
                Offset (0x61), 
//                    ,   3, 
//                UCEN,   1, 
                Offset (0x63), 
                DBT0,8,DBT1,8, //0x65
//                BSCL,   8, //0x66
//                FRMS,   16, //0x68
//                FRS2,   16, //0x6A
                Offset (0x6A),
                DCP0,8,DCP1,8, 
                BCP0,8,BCP1,8, 
                Offset (0x71), 
//                BATI,   1, 
//                FBTF,   1, 
//                FBTM,   1, 
//                PBTC,   1, 
//                RBTA,   1, 
//                BATL,   1, 
//                FBTD,   1, 
//                FBFD,   1, //0x72
//                FBTC,   1, 
//                FBTP,   1, 
//                FBTH,   1, 
//                NILI,   1, 
//                BTGW,   1, 
//                BICP,   1, 
//                BIWC,   1, 
//                ATCD,   1, //0x73 
//                CFBH,   1, 
//                DFBH,   1, 
//                SCHR,   1, 
//                NUFB,   1, 
//                FBCS,   1, 
//                SLIP,   1, 
//                BRFL,   1, 
//                HCLB,   1, //0x74 
//                PLST,   4, 
//                PLAC,   4, //0x75
                Offset (0x75),
                BDV0,8,BDV1,8, 
//                RSOC,   8, 
//                BTMP,   16, 
                Offset (0xAE), 
//                THRP,   8, 
//                OSUT,   8, 
//                PRAL,   8, 
//                PRAH,   8, 
//                CORL,   8, 
//                CORH,   8, 
                Offset (0xCE), 
//                BASN,   16, 
//                MBDN,   120, 
//                DNCT,   8, 
//                NMON,   16, 
//                CYCL,   16, 
//                ECMJ,   8, 
//                ECMN,   8, 
                Offset (0xE7), 
//                BHCH,   8, 
                Offset (0xF0), 
//                ECF0,   1, 
//                FCSL,   1
            }

            Method (_Q20, 0, NotSerialized)  // _Qxx: EC Query, xx=0x00-0xFF
            {
                Notify (BAT1, 0x80) // Status Change
                Acquire (MUT0, 0x5000)
                SELE ()
                Store (B1B2(DBT0,DBT1), TBAT) /* \_SB_.PCI0.LPCB.EC0_.TBAT */
                Store (TBAT, Local1)
                ^^^^BAT1.CHBP (Local1)
                If (ATKP)
                {
                    If (And (0x02, BATF))
                    {
                        If (LEqual (ACIN, One))
                        {
                            ^^^^ATKD.IANE (0x58)
                        }

                        If (LEqual (ACIN, Zero))
                        {
                            ^^^^ATKD.IANE (0x57)
                        }
                    }
                }

                If (And (0x02, BATF))
                {
                    Store (One, ACEV) /* \_SB_.PCI0.LPCB.EC0_.ACEV */
                    Notify (ACAD, Zero) // Bus Check
                    Store (ACIN, PWRS) /* \PWRS */
                    PNOT ()
                }

                If (And (0x40, BATF))
                {
                    Notify (BAT1, Zero) // Bus Check
                    Notify (BAT1, 0x80) // Status Change
                    Notify (BAT1, 0x81) // Information Change
                }

                Release (MUT0)
            }
            Method (SELE, 0, NotSerialized)
            {
                Store (B1B2(DBT0,DBT1), TBAT) /* \_SB_.PCI0.LPCB.EC0_.TBAT */
                Store (TBAT, BATN) /* \_SB_.PCI0.LPCB.EC0_.BATN */
                Store (Zero, BATF) /* \_SB_.PCI0.LPCB.EC0_.BATF */
                If (And (0xC0, BATN))
                {
                    Or (BATF, One, BATF) /* \_SB_.PCI0.LPCB.EC0_.BATF */
                }

                If (And (0x0C00, BATN))
                {
                    Or (BATF, 0x04, BATF) /* \_SB_.PCI0.LPCB.EC0_.BATF */
                }

                And (BATN, 0x0F01, Local0)
                And (BATO, 0x0F01, Local1)
                If (Not (LEqual (Local0, Local1)))
                {
                    Or (BATF, 0x40, BATF) /* \_SB_.PCI0.LPCB.EC0_.BATF */
                }

                And (BATN, 0xC0, Local0)
                And (BATO, 0xC0, Local1)
                If (Not (LEqual (Local0, Local1)))
                {
                    Or (BATF, 0x02, BATF) /* \_SB_.PCI0.LPCB.EC0_.BATF */
                }

                If (And (0x04, BATF))
                {
                    Or (BATF, 0x10, BATF) /* \_SB_.PCI0.LPCB.EC0_.BATF */
                }

                Store (BATN, BATO) /* \_SB_.PCI0.LPCB.EC0_.BATO */
            }
        }
    }

    Scope (_SB)
    {
        Scope (BAT1)
        {
         Method (_BST, 0, NotSerialized)  // _BST: Battery Status
            {
                If (^^PCI0.LPCB.EC0.ECOK)
                {
                    Acquire (^^PCI0.LPCB.EC0.MUT0, 0x5000)
                    Store (B1B2(^^PCI0.LPCB.EC0.DBT0,^^PCI0.LPCB.EC0.DBT1), TBAT) /* \_SB_.BAT1.TBAT */
                    If (And (0xC0, TBAT))
                    {
                        Or (^^PCI0.LPCB.EC0.BATF, One, ^^PCI0.LPCB.EC0.BATF) /* \_SB_.PCI0.LPCB.EC0_.BATF */
                    }
                    Else
                    {
                        And (^^PCI0.LPCB.EC0.BATF, 0xFFFE, ^^PCI0.LPCB.EC0.BATF) /* \_SB_.PCI0.LPCB.EC0_.BATF */
                    }

                    And (TBAT, One, Local0)
                    If (Local0)
                    {
                        UPBS ()
                    }
                    Else
                    {
                        IVBS ()
                    }

                    Release (^^PCI0.LPCB.EC0.MUT0)
                }

                Return (PBST) /* \_SB_.BAT1.PBST */
            }

            Method (UPBI, 0, NotSerialized)
            {
                Store (Zero, Local0)
                Store (0x0C, Local1)
                Acquire (^^PCI0.LPCB.EC0.MUT0, 0x5000)
                Store (B1B2(^^PCI0.LPCB.EC0.DCP0,^^PCI0.LPCB.EC0.DCP1), Index (PBIF, One))
                Store (B1B2(^^PCI0.LPCB.EC0.BCP0,^^PCI0.LPCB.EC0.BCP1), Index (PBIF, 0x02))
                Store (B1B2(^^PCI0.LPCB.EC0.BDV0,^^PCI0.LPCB.EC0.BDV1), Index (PBIF, 0x04))
                Store (B1B2(^^PCI0.LPCB.EC0.BCP0,^^PCI0.LPCB.EC0.BCP1), Local2)
                Store (B1B2(^^PCI0.LPCB.EC0.BCP0,^^PCI0.LPCB.EC0.BCP1), Local3)
                Multiply (Local3, 0x0A, Local3)
                Divide (Local3, 0x64, Local4, Local3)
                Store (Local3, Index (PBIF, 0x05))
                Store (B1B2(^^PCI0.LPCB.EC0.BCP0,^^PCI0.LPCB.EC0.BCP1), Local3)
                Multiply (Local3, 0x05, Local3)
                Divide (Local3, 0x64, Local4, Local3)
                Store (Local3, Index (PBIF, 0x06))
                Store ("A32-K55", Index (PBIF, 0x09))
                Store (" ", Index (PBIF, 0x0A))
                Store ("LiON", Index (PBIF, 0x0B))
                Store ("ASUS ", Index (PBIF, 0x0C))
                Store (Ones, Local0)
                Release (^^PCI0.LPCB.EC0.MUT0)
                Return (Local0)
            }
            Method (UPBS, 0, NotSerialized)
            {
                Store (Zero, Local0)
                Acquire (^^PCI0.LPCB.EC0.MUT0, 0x5000)
                Store (B1B2(^^PCI0.LPCB.EC0.BCT0,^^PCI0.LPCB.EC0.BCT1), Local2)
                If (And (Local2, 0x8000))
                {
                    Or (Local2, 0xFFFF0000, Local2)
                    Add (Not (Local2), One, Local2)
                }

                Store (B1B2(^^PCI0.LPCB.EC0.BVT0,^^PCI0.LPCB.EC0.BVT1), Local3)
                Store (B1B2(^^PCI0.LPCB.EC0.CRP0,^^PCI0.LPCB.EC0.CRP1), Local5)
                Multiply (Local3, 0x14, Local3)
                Divide (Local3, 0x40, Local4, Local3)
                If (LNotEqual (Local2, DerefOf (Index (PBST, One))))
                {
                    Store (Local2, Index (PBST, One))
                    Store (Ones, Local0)
                }

                If (LNotEqual (Local3, DerefOf (Index (PBST, 0x03))))
                {
                    Store (Local3, Index (PBST, 0x03))
                    Store (Ones, Local0)
                }

                If (LNotEqual (Local5, DerefOf (Index (PBST, 0x02))))
                {
                    Store (Local5, Index (PBST, 0x02))
                    Store (Ones, Local0)
                }

                Store (Zero, Local4)
                Store (B1B2(^^PCI0.LPCB.EC0.DBT0,^^PCI0.LPCB.EC0.DBT1), TBAT) /* \_SB_.BAT1.TBAT */
                If (And (0x0C00, TBAT))
                {
                    Or (0x02, Local4, Local4)
                }
                ElseIf (And (0x0100, TBAT))
                {
                    Or (One, Local4, Local4)
                }

                If (LNotEqual (Local4, DerefOf (Index (PBST, Zero))))
                {
                    Store (Local4, Index (PBST, Zero))
                    Store (Ones, Local0)
                }

                Release (^^PCI0.LPCB.EC0.MUT0)
                Return (Local0)
            }
        }
    }
}

